<template>
  <q-modal
    :value="!!field"
    @hide="$emit('close')"
  >
    <div class="q-pa-md" v-if="field">
      <div class="q-title">Edit <b>{{ field.label }}</b> {{parentType}} field configuration</div>

      <div
        class="q-mt-md"
      >
        <component
          :is="editorComponent"
          :field="field"
        />
      </div>
    </div>
  </q-modal>
</template>

<script>
  import textField from './editors/textField';
  import numberField from './editors/numberField';
  import checkboxField from './editors/checkboxField';
  import dropdownField from './editors/dropdownField';
  import collectionField from './editors/collectionField';
  import datetimeField from './editors/datetimeField';
  import childrenField from './editors/childrenField';

  export default {
    name: 'fieldEditor',
    props: {
      field: {
        type: Object,
      },
      parentType: {
        type: String,
      },
    },
    computed: {
      type() {
        return this.field.type;
      },
      editorComponent() {
        return ({
          text: textField,
          number: numberField,
          checkbox: checkboxField,
          dropdown: dropdownField,
          collection: collectionField,
          datetime: datetimeField,
          children: childrenField,
        }[this.type]) || null;
      },
    },
  };
</script>

<style scoped>

</style>
